%G-CODE READER V1.0

function [PM]=Gcoderead(FILENAME)
% FILENAME='myfile.txt';
f=fopen(FILENAME);
Data=textscan(f,'%s');

L=length(Data{1});
N=[];
G=[];
M=[];
P=[];
F=[];
K=[];
X=[];
Y=[];
Z=[];
R=[];

for i=1:L
    t=length(Data{1}{i});
    pr=upper((Data{1}{i}(1)));
    
    switch pr
        case 'N'
            % Instruction number
            N=vertcat(N,str2num(Data{1}{i}(2:t)));
        case 'G'
            % Used with conventional Gcode
            G=vertcat(G,str2num(Data{1}{i}(2:t)));
        case 'M'
            % M-codes
            M=vertcat(M,str2num(Data{1}{i}(2:t)));
        case 'P'
            %Curve order
            P=vertcat(P,str2num(Data{1}{i}(2:t)));
        case 'F'
            %Feedrate
            F=vertcat(F,str2num(Data{1}{i}(2:t)));            
        case 'K'
            % Nodes
            K=vertcat(K,str2num(Data{1}{i}(2:t)));
        case 'X'
            % X-axis control points
            X=vertcat(X,str2num(Data{1}{i}(2:t)));
        case 'Y'
            % Y-axis control points
            Y=vertcat(Y,str2num(Data{1}{i}(2:t)));
        case 'Z'
            % Z-axis control points
            Z=vertcat(Z,str2num(Data{1}{i}(2:t)));
        case 'R'
            % weigth
            R=vertcat(R,str2num(Data{1}{i}(2:t)));
        otherwise
            % ignore the parameter
    end
end
fclose(f)
            PM=[X,Y,Z];
            
    
    
    

