%NURBS INTERPOLATOR

function [x,y,z,tk]=NURBS(CP,W,order,L,Vm,Fs)
% fc=max(max(CP)-min(CP));
CP=[CP,W];

p=order-1;
%GETTING NODES
[n,D]=size(CP);

% K=n-p-1

K=p+n+1;
if(K<1)
    %%%mostrar un warning    
end

if(K>2*p)
    tk=[0*ones(1,p-1),linspace(0,p-1,K-2*p),p*ones(1,p)]./p;
else
    tk=[-1,linspace(-1,p,K-2),p]./p;
end


% tk=[0 0 1 2 3 4 5 5];
% tk=[0 0 0 0.111 0.222 0.333 0.444 0.555 0.666 0.777 0.888 1 1 1];

n=length(CP);
% k=length(tk)-n; %grado del b-spline

% t=tk(p):.002:tk(n+1);

% t=linspace(tk(p),tk(n+1),ND);




ltk=length(tk);

% % % % t=tk(p):Vm/ltk/Fs:tk(n+1); %%%t es unitario

Ki=fix(Fs*15*L/8/Vm);
% t=linspace(0,1,Ki);
t=1:Ki;
t=30/Ki^5*(t.^5./5-Ki*t.^4./2+Ki^2*t.^3/3);
% [t,V,A,J]=prfgen([L,Vm,10,-10,40],'trapacc',Fs);
dt=1/((L/Vm)*Fs);
t=t./max(t);

ND=length(t);

% t=6*t.^5-15*t.^4+10*t.^3;
datos=t;


x=zeros(1,ND);
y=zeros(1,ND);
z=zeros(1,ND);
% ww=zeros(1,ND);
limite=zeros(1,ND);

puntos=length(datos);

for w=1:puntos,
    
    t=datos(w);
    l=lim(t,tk);
    limite(w)=lim(t,tk);
%     l=lim(t,tk);
%     limite=[l limite];
    
    valor=punto(t,l,p-1,p,tk,CP);
    x(w)=valor(1)/valor(D);
    y(w)=valor(2)/valor(D);
%     
%     x=[x valor(1)];
%     y=[y valor(2)];
    if (D>3)
        z(w)=valor(3)/valor(D);
%         z=[z valor(3)];
    end    
%     ww(w)=valor(D);
end
%NURBS GENERATION





function point=punto(t,i,j,k,tk,p)

if i<1
    tki=tk(1);
elseif i<=length(tk)
    tki=tk(i);
else
    tki=tk(length(tk));
end

if i+k-j<1
    tkikj=tk(1);
elseif i+k-j<=length(tk)
    tkikj=tk(i+k-j);
else
    tkikj=tk(length(tk));
end

gamma=(t-tki)/(tkikj-tki);

if j>0,
    point=(1-gamma)*punto(t,i-1,j-1,k,tk,p)+gamma*punto(t,i,j-1,k,tk,p);
else
    if i>0 && i<=length(p)
        point=p(i,:);
    elseif i<=0
        point=p(1,:);
    else
        point=p(length(p),:);
    end
end

%Esta funcion proporciona el indice l tal que data(l)<=x<data(l)

function l=lim(x,data)

n=length(data);
bandera=0;
i=1;

while bandera==0 && i<=n,
    if x>=data(i) && x<=data(i+1),
        l=i;
        bandera=1;
    else
        i=i+1;
    end
end


